package com.dsic.gj_erp.service.jhgk.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jhgk.DmSygd;
import com.dsic.gj_erp.bean.jhgk.DmSygdMx;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.bean.jhgk.excel.SyExcel;
import com.dsic.gj_erp.mapper.jhgk.DmSygdMapper;
import com.dsic.gj_erp.service.jhgk.DmSygdMxService;
import com.dsic.gj_erp.service.jhgk.DmSygdService;
import com.dsic.gj_erp.service.jhgk.DmYdjhService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-10-09
 */
@Service
@AllArgsConstructor
public class DmSygdServiceImpl extends ServiceImpl<DmSygdMapper, DmSygd> implements DmSygdService {

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Map uploadSy(List<SyExcel> list, HttpServletRequest req){
        List<DmSygd> listForSave=new ArrayList<>();
        for (SyExcel q:list) {
            //TODO 处理转码字段
//            this.remove(new QueryWrapper<DmSygd>()
//                    .eq("DC_CH1",q.getDcCh1())
//                    .eq("DC_PL",q.getDcPl())
//                    .eq("DC_FD",q.getDcFd()));
            DmSygd a=new DmSygd();
            BeanUtil.copyProperties(q,a);
//            a.setBzry((String) req.getAttribute("yhms"));
//            a.setBzrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
            a.setGdZt("0");//状态转码
            listForSave.add(a);
        }
        this.saveOrUpdateBatch(listForSave);
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean tj(List<DmSygd> dmSygds){
        dmSygds.forEach(dmSygd->{
            String zt=dmSygd.getGdZt();
            String setZt=zt.equals("1")?"0":"1";
            dmSygd.setGdZt(setZt);
        });
      return this.updateBatchById(dmSygds);
    }


    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean sh(List<DmSygd> dmSygds){
        dmSygds.forEach(dmSygd->{
            String setZt="2";
            dmSygd.setGdZt(setZt);
        });
        return this.updateBatchById(dmSygds);
    }

}
